Open CASCADE Technology: Select3D_SensitiveWire Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
Select3D_SensitiveWire Class Reference

A framework to define selection of a wire owner by an elastic wire band. More...

`#include <Select3D_SensitiveWire.hxx>`

Inheritance diagram for Select3D_SensitiveWire:
[legend]

## Public Member Functions
| Select3D_SensitiveWire (const Handle< SelectBasics_EntityOwner > &OwnerId, const Standard_Integer MaxRect=1)
| Constructs a sensitive wire object defined by the owner OwnerId, and the maximum number of sensitive rectangles MaxRect. More...
void | Add (const Handle< Select3D_SensitiveEntity > &aSensitive)
| Adds the sensitive entity aSensitive to this framework. More...
void | Project (const Handle< Select3D_Projector > &aProjector)
| projection of the sensitive primitive in order to get 2D boxes for the Sort Algorithm More...
void | Areas (SelectBasics_ListOfBox2d &boxes)
| gives the 2D boxes which represent the segment in the selection process... More...
Handle< Select3D_SensitiveEntity > | GetConnected (const TopLoc_Location &aLocation)
| Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity. More...
void | GetEdges (Select3D_SensitiveEntitySequence &theEdges)
| returns the sensitive edges stored in this wire More...
void | SetLocation (const TopLoc_Location &aLoc)
| propagation of location on all the sensitive inside... More...
void | ResetLocation ()
| propagation of location on all the sensitive inside... More...
Standard_Boolean | Matches (const SelectBasics_PickArgs &thePickArgs, Standard_Real &theMatchDMin, Standard_Real &theMatchDepth)
| Checks whether the sensitive entity matches the picking detection area (close to the picking line). For details please refer to base class declaration. More...
Standard_Boolean | Matches (const Standard_Real XMin, const Standard_Real YMin, const Standard_Real XMax, const Standard_Real YMax, const Standard_Real aTol)
| Matches the box defined by the coordinates Xmin, Ymin, Xmax, Ymax with the entity found at that point within the tolerance aTol. Xmin, YMin define the minimum point in the lower left hand corner of the box, and XMax, YMax define the maximum point in the upper right hand corner of the box. You must redefine this function for every inheriting entity. You will have to call this framework inside the redefined function. More...
virtual Standard_Boolean | Matches (const TColgp_Array1OfPnt2d &Polyline, const Bnd_Box2d &aBox, const Standard_Real aTol)
| prevents from hiding virtual methods... More...
Standard_Integer | MaxBoxes () const
| returns <mymaxrect> More...
virtual void | Dump (Standard_OStream &S, const Standard_Boolean FullDump=Standard_True) const
| 2 options : <FullDump> = False -> general information <FullDump> = True -> whole informtion 3D +2d ... More...
void | Set (const Handle< SelectBasics_EntityOwner > &TheOwnerId)
| Sets the owner for all entities in wire. More...
Handle< Select3D_SensitiveEntity > | GetLastDetected () const
| returns <mymaxrect> More...
Public Member Functions inherited from Select3D_SensitiveEntity
Standard_Boolean | NeedsConversion () const
| Returns true if this framework needs conversion. More...
Standard_Boolean | Is3D () const
| Returns true if this framework provides 3D information. More...
virtual Standard_Boolean | HasLocation () const
| Returns true if this framework has a location defined. More...
virtual const TopLoc_Location | Location () const
void | UpdateLocation (const TopLoc_Location &aLoc)
Public Member Functions inherited from SelectBasics_SensitiveEntity
const Handle < SelectBasics_EntityOwner > & | OwnerId () const
void | SetSensitivityFactor (const Standard_ShortReal aFactor)
Standard_ShortReal | SensitivityFactor () const
| allows a better sensitivity for a specific entity in selection algorithms useful for small sized entities. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Additional Inherited Members
Static Public Member Functions inherited from Select3D_SensitiveEntity
static void | DumpBox (Standard_OStream &S, const Bnd_Box2d &abox)
Protected Member Functions inherited from Select3D_SensitiveEntity
| Select3D_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &OwnerId)
Protected Member Functions inherited from SelectBasics_SensitiveEntity
| SelectBasics_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &OwnerId, const Standard_ShortReal aSensitivityFactor=1)
Protected Attributes inherited from SelectBasics_SensitiveEntity
Handle< SelectBasics_EntityOwner > | myOwnerId

## Detailed Description

A framework to define selection of a wire owner by an elastic wire band.

## Constructor & Destructor Documentation

Select3D_SensitiveWire::Select3D_SensitiveWire | ( | const Handle< SelectBasics_EntityOwner > & | OwnerId,
|  | const Standard_Integer | MaxRect = `1`
| ) |  |

Constructs a sensitive wire object defined by the owner OwnerId, and the maximum number of sensitive rectangles MaxRect.

## Member Function Documentation

void Select3D_SensitiveWire::Add | ( | const Handle< Select3D_SensitiveEntity > & | aSensitive | ) |

Adds the sensitive entity aSensitive to this framework.

void Select3D_SensitiveWire::Areas | ( | SelectBasics_ListOfBox2d & | boxes | ) |
| virtual

gives the 2D boxes which represent the segment in the selection process...

Implements SelectBasics_SensitiveEntity.

virtual void Select3D_SensitiveWire::Dump | ( | Standard_OStream & | S,
|  | const Standard_Boolean | FullDump = `Standard_True`
| ) |  | const
| virtual

2 options : <FullDump> = False -> general information <FullDump> = True -> whole informtion 3D +2d ...

Reimplemented from Select3D_SensitiveEntity.

Handle< Select3D_SensitiveEntity > Select3D_SensitiveWire::GetConnected | ( | const TopLoc_Location & | aLocation | ) |
| virtual

Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity.

Reimplemented from Select3D_SensitiveEntity.

void Select3D_SensitiveWire::GetEdges | ( | Select3D_SensitiveEntitySequence & | theEdges | ) |

returns the sensitive edges stored in this wire

Handle< Select3D_SensitiveEntity > Select3D_SensitiveWire::GetLastDetected | ( |  | ) | const

returns <mymaxrect>

Standard_Boolean Select3D_SensitiveWire::Matches | ( | const SelectBasics_PickArgs & | thePickArgs,
|  | Standard_Real & | theMatchDMin,
|  | Standard_Real & | theMatchDepth
| ) |  |
| virtual

Checks whether the sensitive entity matches the picking detection area (close to the picking line). For details please refer to base class declaration.

Implements SelectBasics_SensitiveEntity.

Standard_Boolean Select3D_SensitiveWire::Matches | ( | const Standard_Real | XMin,
|  | const Standard_Real | YMin,
|  | const Standard_Real | XMax,
|  | const Standard_Real | YMax,
|  | const Standard_Real | aTol
| ) |  |
| virtual

Matches the box defined by the coordinates Xmin, Ymin, Xmax, Ymax with the entity found at that point within the tolerance aTol. Xmin, YMin define the minimum point in the lower left hand corner of the box, and XMax, YMax define the maximum point in the upper right hand corner of the box. You must redefine this function for every inheriting entity. You will have to call this framework inside the redefined function.

Reimplemented from Select3D_SensitiveEntity.

virtual Standard_Boolean Select3D_SensitiveWire::Matches | ( | const TColgp_Array1OfPnt2d & | Polyline,
|  | const Bnd_Box2d & | aBox,
|  | const Standard_Real | aTol
| ) |  |
| virtual

prevents from hiding virtual methods...

Reimplemented from Select3D_SensitiveEntity.

Standard_Integer Select3D_SensitiveWire::MaxBoxes | ( |  | ) | const
| virtual

returns <mymaxrect>

Reimplemented from Select3D_SensitiveEntity.

void Select3D_SensitiveWire::Project | ( | const Handle< Select3D_Projector > & | aProjector | ) |
| virtual

projection of the sensitive primitive in order to get 2D boxes for the Sort Algorithm

Implements Select3D_SensitiveEntity.

void Select3D_SensitiveWire::ResetLocation | ( |  | ) |
| virtual

propagation of location on all the sensitive inside...

Reimplemented from Select3D_SensitiveEntity.

void Select3D_SensitiveWire::Set | ( | const Handle< SelectBasics_EntityOwner > & | TheOwnerId | ) |
| virtual

Sets the owner for all entities in wire.

Reimplemented from SelectBasics_SensitiveEntity.

void Select3D_SensitiveWire::SetLocation | ( | const TopLoc_Location & | aLoc | ) |
| virtual

propagation of location on all the sensitive inside...

Reimplemented from Select3D_SensitiveEntity.

The documentation for this class was generated from the following file:

- Select3D_SensitiveWire.hxx